<?php // Ringlink $Id: example.php,v 1.11 2009/01/03 08:48:47 gunnarh Exp $
/*
The purpose with this file is to illustrate how output from the Ringlink
program can be passed to some other program, in this case a PHP script.

To test it, you need to
- Set the three variables below
- Upload this file and example.css
- Set the $rlmain::extappURL variable in rlconfig.pm to the URL of this file

Note that the set-up may behave differently if $rlmain::extappURL includes
the full URL (starting with 'http://'), compared to a relative or absolute
URL. You may want to test both to decide which you prefer.

The configuration of some PHP installations prevents PHP (through the PHP
open_basedir directive) from being able to read files outside the document
root. If that's the case for you, you may need to move the Ringlink data
directory to somewhere outside the cgi-bin.

NOTE: This example script is not consistent with the aim to send more
accurate HTTP status codes.
*/

// Full path to the Ringlink data directory
$datapath = 'C:/Documents and Settings/Administrator/My Documents/Ringlink/localtest/data';

// URL to style sheet
$styleURL = 'example.css';

// If this is set to 0 (zero), the ordinary Ringlink output is displayed
$phpframe = 1;

//---------------------------------------------------------------------------//

function noload() {
    echo "<br /><b>You shall not load (or reload) this file directly. Its purpose is"
        ." to display Ringlink output when called via a redirect from Ringlink.</b>";
}

function charsetheader($datapath, $ret) {
// Prints an HTTP header, as well as returns a meta declaration, with the charset.
    preg_match ('/<meta http-equiv="Content-Type" .+ charset=([\w-]+)" \/>/',
                implode ('', file ("$datapath/top.txt")), $charset);
    if ( isset($charset[1]) && $charset[1] != '' ) {
        header('Content-type: text/html; charset='.$charset[1]);
        if ($ret) {
            return $charset[0]."\n";
        }
    } else {
        trigger_error("Couldn't parse the charset", E_USER_WARNING);
    }
}

function removefiles($datapath) {
    unlink ("$datapath/top.txt");      // This deletes the temporary files
    unlink ("$datapath/main.txt");     // in the Ringlink data directory.
    unlink ("$datapath/bottom.txt");   // Appropriate for security reasons.
}

if ($phpframe) {
    if (is_file ("$datapath/main.txt")) {
        echo "<html>\n"
            ."<head>\n"
            .charsetheader($datapath, 1)
            ."<meta http-equiv=\"Content-Style-Type\" content=\"text/css\" />\n"
            ."<link rel=\"stylesheet\" type=\"text/css\" href=\"$styleURL\" />\n"
            ."</head>\n"
            ."<body>\n"
            ."<center>\n"
            .implode('', file("$datapath/main.txt")) /* Here it grabs the Ringlink output */
            ."</center>\n"
            ."</body>\n"
            ."</html>\n";
        removefiles($datapath);
    } else {
        noload();
    }    
} else {
    if (is_file ("$datapath/main.txt")) {
        charsetheader($datapath, 0);
        echo implode('', file("$datapath/top.txt"))
            .implode('', file("$datapath/main.txt"))
            .implode('', file("$datapath/bottom.txt"));
        removefiles($datapath);
    } else {
        noload();
    }    
}

?>